/* File and display logging function header.
   Rick Smereka, Copyright (C) 1992-2002.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, get a copy via the Internet at
   http://gnu.org/copyleft/gpl.html or write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston,
   MA 02111-1307 USA

   You can contact the author via email at rsmereka@future-lab.com
   
   Original DOS version Sept/92, Rick Smereka.

   Ported to QNX V4.23a. Jan/97, Rick Smereka

   Added information for the calls to the system logging
   service. Feb/97, Rick Smereka

   Added detection of C++ compiler with instructions not to
   mangle the function names. Nov/98, Rick Smereka

   Ported to 32bit Windows under CodeWarrior V4.
   Dec/98, Rick Smereka

   Ported to HP-UX under GNU C 2.8.1.
   Jan/99, Rick Smereka
   
   Ported to Red Hat Linux 5.2, Jul/99, Rick Smereka
   
   Changed function 'log_start' to return a logic flag.
   Jan/2000, Rick Smereka
   
   Added 'log_file_name', 'log_console' and 'log_get_console'
   prototypes. Apr/2000, Rick Smereka

   Changed maximum size of a single message ('MAXMES') to
   2048 bytes. Feb/2001, Rick Smereka

   Added prototype of function 'log_file_date_nf'.
   Oct/2001, Rick Smereka

   Ported to Debian Linux. Nov/2002, Rick Smereka

   Changed function prototype name 'log' to 'logger'. The C++ compiler
   has a function defined as 'log'. Dec/2002, Rick Smereka */

   
#define MAXMES 2048           /* limit of a single message */

#ifdef __cplusplus
extern "C"
{
#endif

int log_start(char *);        /* start logging process */
void logger(char *,...);      /* log to display and file */
void log_file(char *,...);    /* log to file */
void log_file_date(char *,...); /* log to file with date/time prefix */
void log_file_date_nf(char *); /* log to file with date/time no var arg */
void log_disp(char *,...);    /* log to display */
int is_log_active(void);      /* is personal logging active? */
void log_end(void);           /* stop personal logging */
int log_file_name(char *);    /* get log file name */
void log_console(int);        /* turn console output on/off */
int log_get_console(void);    /* get current console output flag */

#ifdef OS_DOS
#define SYS_LOG_MAXMES 8192
int sys_log(char *,...);      /* DOS stub */
int sys_log_nf(char *);
#endif

#ifdef __cplusplus
}
#endif
